NEAR OST_TASK_STATE     OS_state    __osa30_near;

#define OS_Init_ProcSpec()      //  PICC18 -  


/**************************************************************************************************
 * 
 *                                       M C C 1 8 
 *
 *
 **************************************************************************************************/

void _OS_ClrReadySetClrCanContinue (void);

/************************************************************************/
/*                          */
/************************************************************************/

void OS_SchedRetPoint (void)
{
    _OS_SET_FSR_CUR_TASK();
    _OS_SavePC();
    _OS_bTaskReady = 1;
    asm("    global _OS_SchedRetPointNoSave   ");
    asm("_OS_SchedRetPointNoSave:             ");
    _PIC18_POP();
}


/************************************************************************/
/*                                                                      */
/************************************************************************/


asm("   global  _OS_ClearReady");
asm("_OS_ClearReady:     ");
asm("   clrf    __OS_temp, c    ");
asm("   global  __OS_ClrReadySetClrCanContinue  ");
asm("   goto    __OS_ClrReadySetClrCanContinue  ");

/************************************************************************/
/*                                                                      */
/************************************************************************/
asm("   global  _OS_ClearReadySetCanContinue");
asm("_OS_ClearReadySetCanContinue:     ");
asm("   setf    __OS_temp, c    ");
asm("   global  __OS_ClrReadySetClrCanContinue  ");
asm("   goto    __OS_ClrReadySetClrCanContinue  ");


//------------------------------------------------------------------------------
//      
//    GOTO :
//      OS_ClearReady()
//      OS_ClearReadySetCanContinue()
// ,   -  ,  
//------------------------------------------------------------------------------
void _OS_ClrReadySetClrCanContinue (void)
{


    OS_Flags.bEventError = 0;
    
    _OS_SET_FSR_CUR_TASK();
    _OS_SavePC();

    _OS_bTaskReady = 0;

    #if defined(OS_ENABLE_TTIMERS)
        _OS_bTaskCanContinue = 0;
        if (_OS_temp & 0x01) _OS_bTaskCanContinue = 1;
    #endif

}
















/**************************************************************************************************
 * 
 *            F S R       O S _ C U R _ T A S K
 *
 *   
 *
 **************************************************************************************************/

asm("   global __OS_SET_FSR_CUR_TASK        ");
asm("__OS_SET_FSR_CUR_TASK:                 ");
    _PIC18_ERRATA_NOP();
    asm("       movf        __OS_CurTask+0, w, c");
    asm("       movwf       __fsr + 0, c        ");
#if OS_BANK_TASKS == 0
    asm("       clrf        __fsr + 1, c        ");
#else 
    asm("       movf        __OS_CurTask+1, w, c");
    asm("       movwf       __fsr + 1, c        ");
#endif
    asm("       return                          ");



















/**************************************************************************************************
 * 
 * C O U N T I N G    S E M A P H O R E S
 *
 * (OS_ENABLE_CSEM must be defined in OSAcfg.h)
 *
 **************************************************************************************************/


#ifdef OS_ENABLE_CSEM



/************************************************************************/
/*     1                                    */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_SignalCSem_DEFINED
//------------------------------------------------------------------------------
void _OS_SignalCSem (OST_CSEM *pCSem)
{
    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif

    OS_Flags.bEventError = 0;               //   ,    

    //------------------------------------------------------------------------------
    //    
    #if OS_CSEM_SIZE == 1
    
        _fsr = (_FSR_TYPE)pCSem;
        #ifdef __OSAPICC__
            _status &= 0x7F;        //  IRP
        #endif
        _indf++;
        if (!_indf)
        {
            _indf--;
            OS_Flags.bEventError = 1;
        }
    //------------------------------------------------------------------------------
    //    
    //    
    #else 
        (*pCSem)++;
        if (!*pCSem) {          //   ,    
            (*pCSem) = -1;
            OS_Flags.bEventError = 1;
        }
    #endif
    //------------------------------------------------------------------------------
    
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}

#endif











/****************************************************************************************************
 * 
 *       GIEH:GIEL
 * 
 * char OS_DI (void)   
 *
 ****************************************************************************************************/
/****************************************************************************************************
 * 
 *       OS_DI 
 * 
 * void OS_RI (char)   
 *
 ****************************************************************************************************/
//------------------------------------------------------------------------------
#define OS_DI_DEFINED
//------------------------------------------------------------------------------
asm("   global _OS_DI           ");
asm("_OS_DI:                    ");
asm("   dw      0xFFFF          ");
asm("   movf    __intcon, w, c   ");
asm("   andlw   0xC0            ");
asm("_DIH_REPEAT:               ");
asm("   bcf     __intcon, 7, c   ");
asm("   btfsc   __intcon, 7, c   ");
asm("   bra     _DIH_REPEAT     ");

asm("   btfss   __rcon, 7, c     ");
asm("   bra     _DI_EXIT        ");
asm("_DIL_REPEAT:               ");
asm("   bcf     __intcon, 6, c   ");
asm("   btfsc   __intcon, 6, c   ");
asm("   bra     _DIL_REPEAT     ");
asm("_DI_EXIT:                  ");
asm("   return                  ");
asm("   dw      0xFFFF          ");


asm("   global  _OS_RI          ");
asm("_OS_RI:                    ");
asm("   dw      0xFFFF          ");
asm("   btfsc   _WREG, 7, c     ");
asm("   bsf     __intcon, 7, c   ");
asm("   btfsc   __rcon, 7, c     ");
asm("   btfss   __wreg, 6, c     ");
asm("   bra     _RI_EXIT        ");
asm("   bsf     __intcon, 6, c   ");
asm("_RI_EXIT:                  ");
asm("   return                  ");
asm("   dw      0xFFFF          ");














 
    
    
/****************************************************************************************************
 * 
 *        
 * 
 *
 ****************************************************************************************************/
//------------------------------------------------------------------------------
#ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------
    
/************************************************************************/
/*                                                */
/************************************************************************/
//------------------------------------------------------------------------------
#define OS_EnterCriticalSection_DEFINED
//------------------------------------------------------------------------------
void OS_EnterCriticalSection (void)
{
    _OST_INT_TYPE temp;
    temp = OS_DI();
    OS_Flags.bInCriticalSection = 1; 

    OS_Flags.bGIE_CTemp = 0;
    if (temp & 0x80) OS_Flags.bGIE_CTemp = 1;

    OS_Flags.bGIEL_CTemp = 0;
    if (temp & 0x40) OS_Flags.bGIEL_CTemp = 1;
}

/************************************************************************/
/*                                              */
/************************************************************************/
//------------------------------------------------------------------------------
#define OS_LeaveCriticalSection_DEFINED
//------------------------------------------------------------------------------
void OS_LeaveCriticalSection (void)
{
    char temp;
    OS_Flags.bInCriticalSection = 0; 
    temp = 0;
    if (OS_Flags.bGIE_CTemp) temp |= 0x80;
    if (OS_Flags.bGIEL_CTemp) temp |= 0x40;
    OS_RI(temp);
}

//------------------------------------------------------------------------------
#endif      //     #ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------


















//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TTIMERS

/****************************************************************************************************
 * 
 *                                  
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_InitDelay_DEFINED
//------------------------------------------------------------------------------
void _OS_InitDelay (_OST_TTIMER Delay)
{

    _OS_bTaskCanContinue = 0;
    _OS_bTaskDelay = 0;
    _OS_SET_FSR_CUR_TASK();
    _indf = *((near char*)&OS_state);

    if (Delay)
    {

        Delay ^= -1;
        Delay ++;
        
        _OS_CurTask->Timer = Delay;
        
        _OS_bTaskDelay = 1;
        _OS_bTaskReady = 1;
        _OS_SET_FSR_CUR_TASK();
        _indf = *((near char*)&OS_state);

    }
}

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER



    










    
    
    
    
    

    





















    
    
    
    
    
/****************************************************************************************************
 * 
 * 
 *                                      
 *  
 *
 ****************************************************************************************************/
    
/************************************************************************/
/*                                                                      */
/*                     */
/*                                   */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_StopTask_DEFINED
//------------------------------------------------------------------------------

void _OS_StopTask (void)
{
    *((OS_TASKS_BANK _OST_INT_TYPE*)&_OS_CurTask->State) = 0;
    *((NEAR _OST_INT_TYPE*)&OS_state) = 0;
}




/************************************************************************/
/*                                                                      */
/*     .                              */
/*  :                                                           */
/*      FSR -                                      */
/*      CARRY - =1 - ,                                                */
/*              =0 -    (  OS_TASKS)    */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
#define _OS_CreateTask_DEFINED
//------------------------------------------------------------------------------
bit _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    OST_TASK_POINTER Task;
    
    OS_Flags.bError = 0;

    #if defined(OS_DISABLE_PRIORITY)
    priority = 0;   //    
    #endif

    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;
            ((OST_TASK_STATE*)&priority)->bReady = 1;
            
            Task->pTaskPointer = TaskAddr;
            #ifdef OS_ENABLE_TTIMERS
                Task->Timer = 0;
            #endif
            #ifdef __OSA18__
                Task->cTempFSR1 = 0;
            #endif
            *((OS_TASKS_BANK char*)&Task->State) = priority;
            if (Task == _OS_CurTask) *((NEAR char*)&OS_state) = priority;
            _fsr = (_FSR_TYPE)Task;
            //    FSR =    
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);
    //  ,     
    OS_Flags.bError = 1;
    return 0;
}

































 /******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_CreatePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_CreatePTimer (OST_PTIMER *ptimer)
{
    _OS_temp = OS_DI();
    
    _fsr = (_FSR_TYPE) ptimer;
    _postinc = *((OS_BANK char*)&_OS_PTimers.Flags);   //  bActive,
                                                    //  bTimeout,
                                                    //  bRun
                                                    //  bNextEnable
    _postinc = *((OS_BANK char*)&_OS_PTimers.Next + 0);
    _postinc = *((OS_BANK char*)&_OS_PTimers.Next + 1);
    _postinc = 0;
    #if  OS_PTIMER_SIZE >= 2
    _postinc = 0;
    #endif
    #if  OS_PTIMER_SIZE == 4
    _postinc = 0;
    _postinc = 0;
    #endif
        


    _OS_PTimers.Next = (OST_PTIMER*)ptimer;
    _OS_PTimers.Flags.bNextEnable = 1;
    
    OS_RI(_OS_temp);
}





/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_DeletePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_DeletePTimer (OST_PTIMER *ptimer)
{
    OST_PTIMER *ptcb;
    
    char flags;
    _fsr = (_FSR_TYPE)ptimer;
    _OS_ClearIndfTimerActive;           //   
    flags = _postinc;
    *((char*)&ptcb + 0) = _postinc;
    *((char*)&ptcb + 1) = _postinc;
    _fsr = (_FSR_TYPE)&_OS_PTimers;
REPEAT:
    if (_OS_CheckPostincTimerNextEnable)
    {
        if (_indf == *((char*)&ptimer + 0))
        {
            if (_preinc == *((char*)&ptimer + 1)){
                _OS_temp = OS_DI();
                _postdec = *((char*)&ptcb + 1);
                _postdec = *((char*)&ptcb + 0);
                if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                return;
            }
            _fsr--;
        } 
        asm("   movf    __postinc, w, c     ");
        asm("   movff   __indf, __fsr + 1     ");
        asm("   movwf   __fsr + 0, c      ");
        goto REPEAT;
    }
    
}



#endif  //  OS_ENABLE_PTIMERS


























/****************************************************************************************************
 * 
 *                                /               
 *                  
 *
 * (  )
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#define _OS_CheckEvent_DEFINED
//------------------------------------------------------------------------------
void _OS_CheckEvent (_OST_INT_TYPE bEvent)
{

    OS_Flags.bTimeout = 0;
    _OS_SET_FSR_CUR_TASK();
    if (bEvent) {
        if (_OS_bTaskReady) {
            #ifdef OS_ENABLE_TTIMERS
                _OS_bTaskDelay = 0; //  bDelay    OS_state
                _indf &= ~0x10;     //  bDelay    
            #endif
            return;
        }
        _OS_bTaskReady = 1;
    } else {
        _OS_bTaskReady = 0;
    }
    #ifdef OS_ENABLE_TTIMERS
        if (_OS_bTaskTimeout && _OS_bTaskCanContinue) {
            OS_Flags.bTimeout = 1;
            return;
        }
    #endif
    _PIC18_POP();
}


    

        

        






