
//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     C                                                                          */
/*                                                                                                              */
/****************************************************************************************************************/


//        
#if defined(OS_ENABLE_INT_SERVICE) && (OS_CSEM_SIZE > 1)
    #define __OS_CSEM_DI()       {_OS_temp = OS_DI();}
    #define __OS_CSEM_RI()       {OS_RI(_OS_temp);}
#else
    #define __OS_CSEM_DI()
    #define __OS_CSEM_RI()
#endif



//------------------------------------------------------------------------------
//      1
#define OS_SignalCSem(countsem)                     _OS_SignalCSem(&countsem)

//------------------------------------------------------------------------------
//    
#define OS_SetCSemValue(countsem,value)                                 \
    {                                                                   \
        __OS_CSEM_DI();                                                 \
        countsem = value;                                               \
        __OS_CSEM_RI();                                                 \
    }

//------------------------------------------------------------------------------
//   (  ,    )
#define OS_AcceptCSem(countsem)                                         \
    {                                                                   \
        __OS_CSEM_DI();                                                 \
        countsem--;                                                     \
        __OS_CSEM_RI();                                                 \
    }

//      1
#define OS_SetCSem(countsem)                        OS_SetCSemValue(countsem, 1)


//------------------------------------------------------------------------------
#if (OS_CSEM_SIZE == 1) || (!defined(OS_ENABLE_INT_SERVICE))


    //   
    #define OS_ResetCSem(countsem)                      {countsem = 0;}
    #define OS_CreateCSem(countsem)                     {countsem = 0;}

    //   
    #define OS_CheckCSem(countsem)                      (countsem)

#else

    //   
    #define OS_ResetCSem(countsem)                      _OS_ClearCSem(&countsem)
    #define OS_CreateCSem(countsem)                     _OS_ClearCSem(&countsem)

    //   
    #define OS_CheckCSem(countsem)                      _OS_CheckCSem(&countsem)

#endif
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
#ifdef OS_ENABLE_INT_SERVICE
    //    
    #define OS_IntSetCSemValue(countsem,value)          {countsem = value;}

    //      1
    #define OS_IntSetCSem(countsem)                     OS_IntSetCSemValue(countsem, 1)

    //   
    #define OS_IntResetCSem(countsem)                   {countsem = 0;}

    //   
    #define OS_IntCheckCSem(countsem)                   (countsem)

    //   
    #define OS_IntAcceptCSem(countsem)                  {countsem--;}

    //      1
    #define OS_IntSignalCSem(countsem)                  _OS_SignalCSem(&countsem)

#endif


//------------------------------------------------------------------------------
//  
#define OS_WaitCSem(countsem)                                           \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckCSem(countsem));                         \
        OS_AcceptCSem(countsem);                                        \
    }

//------------------------------------------------------------------------------
//    
#define OS_WaitCSemTimeout(countsem, timeout)                           \
    {                                                                   \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckCSem(countsem), timeout);        \
        if (!OS_IsTimeout()) {                                \
            OS_AcceptCSem(countsem);                                    \
        }                                                               \
    }


