

//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     Q U E U E   O F   M E S S A G E S                                                        */
/*                                                                                                              */
/****************************************************************************************************************/

#ifdef OS_ENABLE_QMSG

extern void _OS_SendQMsg (OST_QMSG *pQMsg, OST_MSG Msg);
extern OST_MSG _OS_GetQMsg (OST_QMSG *pQMsg);


//------------------------------------------------------------------------------
//   

#define OS_CreateQMsg(qmsg, buffer, size)               \
    {                                                   \
        (qmsg).Q.cSize = size;                          \
        (qmsg).Q.cBegin = 0;                            \
        (qmsg).Q.cFilled = 0;                           \
        (qmsg).pMsg = (OST_MSG*)buffer;                 \
    }

//------------------------------------------------------------------------------
//        
#define OS_CheckQMsg(qmsg)        ((qmsg).Q.cFilled)

//------------------------------------------------------------------------------
//    
#define OS_IsQMsgFull(qmsg)       ((qmsg).Q.cFilled == (qmsg).Q.cSize)

//------------------------------------------------------------------------------
// ,     
#define OS_IsQMsgFree(qmsg)       ((qmsg).Q.cFilled ^ (qmsg).Q.cSize)


//------------------------------------------------------------------------------
//   
#define OS_ClearQMsg(qsmsg)        { (qmsg).Q.cFilled = 0; }

//------------------------------------------------------------------------------
//    
#define OS_SendQMsg(qmsg, value)                                        \
    {                                                                   \
        if (OS_IsQMsgFull(qmsg))                                        \
        {                                                               \
            _OS_WAIT_EVENT(OS_IsQMsgFree(qmsg));                        \
        }                                                               \
        _OS_SendQMsg(&(qmsg), value);                                   \
    }                                                                   \


//------------------------------------------------------------------------------
//      
#define OS_SendQMsgTimeout(qmsg, value, timeout)                        \
    {                                                                   \
        if (OS_IsQMsgFull(qmsg))                                        \
        {                                                               \
            _OS_WAIT_EVENT_TIMEOUT(OS_IsQMsgFree(qmsg), timeout);       \
            if (!OS_IsTimeout()) {                                      \
                _OS_SendQMsg(&(qmsg), value);                           \
            }                                                           \
        } else _OS_SendQMsg(&(qmsg), value);                            \
    }

//------------------------------------------------------------------------------
//          
#define OS_SendQMsgNoWait(qmsg, value)                                  \
    {                                                                   \
        _OS_SendQMsg(&(qmsg), value);                                   \
    }


//------------------------------------------------------------------------------
//    
#define OS_WaitQMsg(qmsg, os_msg_type_var)                              \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckQMsg(qmsg));                             \
        os_msg_type_var = _OS_GetQMsg(&(qmsg));                         \
    }

//------------------------------------------------------------------------------
//      
#define OS_WaitQMsgTimeout(qmsg, os_msg_type_var, timeout)              \
    {                                                                   \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckQMsg(qmsg), timeout);            \
        if (!OS_IsTimeout())                                            \
        {                                                               \
            os_msg_type_var = _OS_GetQMsg(&(qmsg));                     \
        }                                                               \
    }

//------------------------------------------------------------------------------
//     (    ,   )
#define OS_AcceptQMsg(qmsg)    _OS_GetQMsg(&(qmsg))

#endif

