
//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     S I M P L E     M E S S A G E S                                                          */
/*                                                                                                              */
/****************************************************************************************************************/

//------------------------------------------------------------------------------
// ,   
#define OS_CheckSMsg(smsg)       (smsg != (OST_SMSG)0)

//------------------------------------------------------------------------------
// ,   
#define OS_IsSMsgFree(smsg)       (smsg == (OST_SMSG)0)

//------------------------------------------------------------------------------
//    (, )
#define _OS_MakeSMsgFree(smsg)          smsg = (OST_SMSG)0

//------------------------------------------------------------------------------
//   
#define OS_CreateSMsg(smsg)             smsg = (OST_SMSG)0

//------------------------------------------------------------------------------
//  
#define OS_SendSMsg(smsg, message)                                      \
    {                                                                   \
        if (OS_CheckSMsg(smsg))                                         \
            _OS_WAIT_EVENT(OS_IsSMsgFree(smsg));                        \
        smsg = (OST_SMSG) message;                                      \
    }

//------------------------------------------------------------------------------
//  ,  ,   ,   
#define OS_SendSMsgNoWait(smsg, message)                                \
    {                                                                   \
        __OS_MSG_DI();                                                  \
        OS_Flags.bEventError = 0;                                       \
        if (OS_CheckSMsg(smsg)) OS_Flags.bEventError = 1;               \
        smsg = (OST_SMSG) message;                                      \
        __OS_MSG_RI();                                                  \
    }


//------------------------------------------------------------------------------
#ifdef OS_ENABLE_INT_SERVICE
//  ,  ,   ,   
#define OS_IntSendSMsgNoWait(smsg, message)                             \
    {                                                                   \
        OS_Flags.bEventError = 0;                                       \
        if (OS_CheckSMsg(smsg)) OS_Flags.bEventError = 1;               \
        smsg = (OST_SMSG) message;                                      \
    }
#endif

//------------------------------------------------------------------------------
//    
#define OS_SendSMsgTimeout(smsg, message, timeout)                  \
    {                                                               \
        if (OS_CheckSMsg(smsg))                                     \
        {                                                           \
            _OS_WAIT_EVENT_TIMEOUT(OS_IsSMsgFree(smsg), timeout);   \
            if (!OS_IsTimeout()) {                                  \
                smsg = (OST_SMSG) message;                          \
            }                                                       \
        } else {                                                    \
            smsg = (OST_SMSG) message;                              \
        }                                                           \
    }                                                    


//------------------------------------------------------------------------------
//   smsg.
//      var  OST_SMSG
#define OS_WaitSMsg(smsg, os_smsg_type_var)                         \
    {                                                               \
        _OS_WAIT_EVENT(OS_CheckSMsg(smsg));                         \
        os_smsg_type_var = smsg;                                    \
        _OS_MakeSMsgFree(smsg);                                     \
    }


//------------------------------------------------------------------------------
//   smsg  .
//      var  OST_SMSG
#define OS_WaitSMsgTimeout(smsg, os_smsg_type_var, timeout)         \
    {                                                               \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckSMsg(smsg), timeout);        \
        if (!OS_IsTimeout()) {                                      \
            os_smsg_type_var = smsg;                                \
            _OS_MakeSMsgFree(smsg);                                 \
        }                                                           \
    }

//------------------------------------------------------------------------------
//   .      
//   ,   .     
// 
#define OS_AcceptSMsg(smsg, os_smsg_type_var)                       \
    {                                                               \
        os_smsg_type_var = smsg;                                    \
        _OS_MakeSMsgFree(smsg);                                     \
    }





